/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package in.ac.gpckasargod.student.registration;

import in.ac.gpckasargod.student.registration.model.db.Registration;
import in.ac.gpckasargod.student.registration.model.ui.RegistrationUIModel;
import in.ac.gpckasargod.student.registration.service.RegistrationService;
import in.ac.gpckasargod.student.registration.service.impl.RegistrationServiceImpl;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.util.List;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import javax.swing.table.DefaultTableModel;
/**
 *
 * @author mkabh
 */

public class StudentRegistration extends javax.swing.JFrame {
    
    private RegistrationService registrationService = new RegistrationServiceImpl();;

    /**
     * Creates new form StudentRegistration
     */
    public StudentRegistration() {
        
        initComponents();
        tblStudentRegistration.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                //throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
                btnEdit.setEnabled(true);
                btnDelete.setEnabled(true);
            }
        });
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int height = screenSize.height;
        int width = screenSize.width;
        //setSize(width/2, height/2);
        //setLocationRelativeTo(null);
        setExtendedState(JFrame.MAXIMIZED_BOTH);
        configureTableColumns();
        pupulateTable();
    }
    
    
    private void configureTableColumns(){
        DefaultTableModel model = new DefaultTableModel();
        model.addColumn("Id");
        model.addColumn("Name");
        model.addColumn("Admission No");
        model.addColumn("Reg No");
        model.addColumn("Email Id");
        model.addColumn("DOB");
        model.addColumn("Gender");
        model.addColumn("Department");
        tblStudentRegistration.setModel(model);
        tblStudentRegistration.getColumn("Id").setMinWidth(0); // Must be set before maxWidth!!
        tblStudentRegistration.getColumn("Id").setMaxWidth(0);
        tblStudentRegistration.getColumn("Id").setWidth(0);
    }
    
    private void pupulateTable(){
        // "Name", "Admission No", "Reg No", "Department","DOB","Gender","Email"
        
        //RegistrationUIModel uiModel = new RegistrationUIModel();
        //uiModel.setName("Abhijith M K");
        //uiModel.setAdmissionNo("11111");
        //uiModel.setRegNo("1");
        //uiModel.setEmailId("abhijithmk@gpckasaragod.ac.in");
        //uiModel.setDob("dd-MM-yyyy");
        //uiModel.setGender("M");
        //uiModel.setDepartmentId(1);
        DefaultTableModel model = (DefaultTableModel) tblStudentRegistration.getModel();
        model.setRowCount(0);
        List<RegistrationUIModel> registrations = registrationService.getAll();
        for(RegistrationUIModel uiModel:registrations){
            model.addRow(new Object[]{uiModel.getId(),uiModel.getName(),uiModel.getAdmissionNo(),
            uiModel.getRegNo(),uiModel.getEmailId(),uiModel.getDob(),
            uiModel.getGender(),uiModel.getDepartment()});
        }
        
        
    }
    
    private class RegistrationWindowListener extends WindowAdapter{
        @Override
        public void windowClosing(WindowEvent e) {
            System.out.println("A is closing");
            btnDelete.setEnabled(false);
            btnEdit.setEnabled(false);
            tblStudentRegistration.clearSelection();
        }
        
        @Override
        public void windowClosed(WindowEvent e) {
            System.out.println("A has closed");
            DefaultTableModel model = (DefaultTableModel) tblStudentRegistration.getModel();
            List<RegistrationUIModel> registrations = registrationService.getAll();
            model.setRowCount(0);
            for(RegistrationUIModel uiModel:registrations){
                model.addRow(new Object[]{uiModel.getId(),uiModel.getName(),uiModel.getAdmissionNo(),
                uiModel.getRegNo(),uiModel.getEmailId(),uiModel.getDob(),
                uiModel.getGender(),uiModel.getDepartment()});
            }
            btnDelete.setEnabled(false);
            btnEdit.setEnabled(false);
            tblStudentRegistration.clearSelection();
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        tblStudentRegistration = new javax.swing.JTable();
        btnAdd = new javax.swing.JToggleButton();
        btnEdit = new javax.swing.JButton();
        btnDelete = new javax.swing.JToggleButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        tblStudentRegistration.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        jScrollPane1.setViewportView(tblStudentRegistration);

        btnAdd.setText("Add");
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddActionPerformed(evt);
            }
        });

        btnEdit.setText("Edit");
        btnEdit.setEnabled(false);
        btnEdit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnEditActionPerformed(evt);
            }
        });

        btnDelete.setText("Delete");
        btnDelete.setEnabled(false);
        btnDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDeleteActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 844, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnAdd, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnEdit, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnDelete, javax.swing.GroupLayout.PREFERRED_SIZE, 81, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 275, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(btnEdit, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btnDelete))
                    .addComponent(btnAdd, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(193, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddActionPerformed
        // TODO add your handling code here:
        tblStudentRegistration.clearSelection();
        btnDelete.setEnabled(false);
        btnEdit.setEnabled(false);
        JFrame window = new JFrame();
        RegistrationForm registrationForm = new RegistrationForm();
        window.setVisible(true);
        window.add(registrationForm);
        window.pack();
        //window.setSize(400, 300);
        //Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        //int height = screenSize.height;
        //int width = screenSize.width;
        //window.setSize(width/2, height/2);
        window.setLocationRelativeTo(null);
        window.addWindowListener(new RegistrationWindowListener());
       
    }//GEN-LAST:event_btnAddActionPerformed

    private void btnDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDeleteActionPerformed
        // TODO add your handling code here:
        int result = JOptionPane.showConfirmDialog(this,"Sure? You want to delete this record?", "Delete",
               JOptionPane.YES_NO_OPTION,
               JOptionPane.QUESTION_MESSAGE);
        if(result == JOptionPane.YES_OPTION){
            int rowIndex = tblStudentRegistration.convertRowIndexToModel(tblStudentRegistration.getSelectedRow());
            Integer id = (Integer)tblStudentRegistration.getModel().getValueAt(rowIndex,0);
            String messgae = registrationService.deleteRegistration(id);
            JOptionPane.showMessageDialog(this, messgae);
            pupulateTable();
        }
        
        
    }//GEN-LAST:event_btnDeleteActionPerformed

    private void btnEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnEditActionPerformed
        // TODO add your handling code here:
        int rowIndex = tblStudentRegistration.convertRowIndexToModel(tblStudentRegistration.getSelectedRow());
        Integer id = (Integer)tblStudentRegistration.getModel().getValueAt(rowIndex,0);
        Registration registration = registrationService.readRegistration(id);
        if(registration != null)
        {
            RegistrationForm registrationForm = new RegistrationForm(registration);
            JFrame window = new JFrame();
            window.setVisible(true);
            window.add(registrationForm);
            window.pack();
            window.setLocationRelativeTo(null);
            window.addWindowListener(new RegistrationWindowListener());
        }
        
    }//GEN-LAST:event_btnEditActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(StudentRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(StudentRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(StudentRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(StudentRegistration.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new StudentRegistration().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton btnAdd;
    private javax.swing.JToggleButton btnDelete;
    private javax.swing.JButton btnEdit;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable tblStudentRegistration;
    // End of variables declaration//GEN-END:variables
}
